#include <emmintrin.h>
#include <cmath>
#include <cstdint>
#include <cstdio>

#include <static_image.h>
#include <benchmark.h>

#include "image_io.h"

extern "C" {
#include "denoising.h"
}

double t;

Image<float> halide_denoising(Image<float> in) {

    const int trials = 2;
    const int iterations = 2;

    Image<float> out(in.width(), in.height(), 3);
    Image<float> input_n(in.width(), in.height(), 3);

    input_n = in;

    t = benchmark(trials, iterations, [&]() {
	for ( int i = 0; i < 25; i++ ) {
		denoising(input_n, in, out);
		input_n = out;
	}
    });

    return out;
}

int main(int argc, char **argv) {

    Image<float> input = load<float>(argv[1]);

    Image<float> halide = halide_denoising(input);
    double halide_time = t;

    printf("Time: %f \n", halide_time);

    save(halide, "result.png");
    save(input, "input.png");

    return 0;
}
